︠6812a6b0-e986-430b-adeb-060428b504dci︠
%html
<h1><center>Initial Segment Attack</center></h1>
︡ee30688f-579b-4da6-9f4f-710ee4603e7f︡{"done":true,"html":"<h1><center>Initial Segment Attack</center></h1>"}
︠c29ed099-f19c-40e4-81bc-3f83a72257b6i︠
%md
<b>Description.</b> The main idea of this attack is to compute the value $x=(R-(R \mod 10^j))/10^j$ for j=1, 2, ... k where k is the number of tdigits of the modulus R and each step to find gcd(x, R). The attack works if R is a product of two primes such that one of the primes has many consecutive zeros and the otheprime is relatively small. 
︡67a4f801-bca7-4a53-b3d1-964bb676aa91︡{"done":true,"md":"<b>Description.</b> The main idea of this attack is to compute the value $x=(R-(R \\mod 10^j))/10^j$ for j=1, 2, ... k where k is the number of tdigits of the modulus R and each step to find gcd(x, R). The attack works if R is a product of two primes such that one of the primes has many consecutive zeros and the otheprime is relatively small."}
︠b347f093-a222-48eb-8d8e-2d12c4688550s︠
####################################################################################################################################
# The ISAttack uses only one input - the modulus R. If successful, the function provides only one of the primes.                   #
####################################################################################################################################

def ISAttack (R):
    R = ZZ(R)
    n = R.ndigits()
    for j in range(1, n + 1):
        x=(R-(R % 10^j))/10^j
        p = gcd(x, R)
        if ((1 < p)and (p<R)):
            return(p)
    print("no factor found")
︡8ffd7bdd-cfb3-43f7-8d13-408b925523d9︡{"done":true}
︠2d9b0ad7-705a-4918-9395-e2e852608ceas︠
############################################
#                    EXAMPLE               #
############################################

R=580096039015263184152637189359470000000019641046990280564502805826096423
p=ISAttack(R)
print('p=',p)
print('q=',R/p)

︡cf27ff57-2e3d-41f7-88fa-c4003cf19f90︡{"stdout":"p= 456768534657687546576879676661\n"}︡{"stdout":"q= 1270000000000000000000000000000000000000043\n"}︡{"done":true}
︠27454e2e-6274-4d81-b8a3-1793bee4a397s︠
def isqrt(n):
    return int(floor(sqrt(n)))

def usqrt (n):
    ur = isqrt(n)
    if ur ** 2 < n:
        ur = ur + 1
    return(ur)

def FermatAttack (n, rounds):
    st = usqrt(n)
    for x in range(st, st + rounds + 1):
        sq = x ** 2 - n
        y = isqrt(sq)
        if y ** 2 == sq:
            print("Factor found in round %d\n", x - st + 1)
            return(x + y)
    print("No factors found in %d \n", rounds)
n = 1380329510951197510100010724038844435804781490991185453524669
def ISAttack (R):
    R = ZZ(R)
    n = R.ndigits()
    for j in range(1, n + 1):
        x=(R-(R % 10^j))/10^j
        p = gcd(x, R)
        if ((1 < p)and (p<R)):
            return(p)
    print("no factor found")

#FermatAttack(n, 100000)

n
factor(n)
#ISAttack(n)
︡d76d9ebe-b623-4713-b140-8e5752165af9︡{"stdout":"1380329510951197510100010724038844435804781490991185453524669\n"}︡{"stdout":"678313966378204911693968634971 * 2034941899134614735081905904839"}︡{"stdout":"\n"}︡{"done":true}










